import requests
from requests.adapters import HTTPAdapter
from requests.packages.urllib3.util.retry import Retry
import json
import threading
import time
from telebot import TeleBot, types
from concurrent.futures import ThreadPoolExecutor

TOKEN = ('替换')  
ALLOWED_USERS = ['授权用户']  
ADMIN_USERS = ['管理员ID']  

URL = ""

headers = {
'Host': '',
'Connection': '',
'Content-Length': '',
'content-type': '',
'token': '',
'Accept-Encoding': '',
'Referer': ''
}


# 核验函数
def verify_identity(name, phone, id_card, chat_id, bot):
    start_time = time.time()
    payload = {
        "name": name,
        "idCard": id_card,
    }
if response.status_code == 200:
    try:
        response_json = response.json()
        if "errorCode" in response_json:
            error_code = response_json["errorCode"]
            error_message = 
            if error_code != 12:
                print(f'三要素核验失败❌')
            else:
                print("三要素核验一致✅:")
                print(response_json)
    print(response.text)

def process_batch(name, id_cards, phone, chat_id, bot):
    with ThreadPoolExecutor(max_workers=1000) as executor:
        for id_card in id_cards:
            executor.submit(verify_identity, name, phone, id_card.strip(), chat_id, bot)

bot = TeleBot(TOKEN)

@bot.message_handler(commands=['start'])
def send_start(message):
    user_id = str(message.from_user.id)
    if user_id in ALLOWED_USERS:
        keyboard = types.ReplyKeyboardMarkup(one_time_keyboard=True, resize_keyboard=True)
        keyboard.add(types.KeyboardButton('春洛批量三要素'), types.KeyboardButton('/qx'))
        bot.send_message(message.chat.id, "请选择你要进行的功能", reply_markup=keyboard)
    elif user_id in ADMIN_USERS:
        keyboard = types.ReplyKeyboardMarkup(one_time_keyboard=True, resize_keyboard=True)
        keyboard.add(types.KeyboardButton('/qx'), types.KeyboardButton('/list_users'))
        bot.send_message(message.chat.id, "请选择你要进行的功能", reply_markup=keyboard)
    else:
        bot.send_message(message.chat.id, f"您无法使用该机器人,您的 UID 为: {user_id}")

@bot.message_handler(commands=['qx'])
def grant_access(message):
    user_id = str(message.from_user.id)
    if user_id not in ADMIN_USERS:
        bot.send_message(message.chat.id, "您没有权限执行此操作。")
        return

    bot.send_message(message.chat.id, "请输入要授权的用户ID:")
    bot.register_next_step_handler(message, add_user)

def add_user(message):
    user_id = message.text.strip()
    if user_id in ALLOWED_USERS:
        bot.send_message(message.chat.id, "该用户已经拥有权限。")
    else:
        ALLOWED_USERS.append(user_id)
        bot.send_message(message.chat.id, f"用户 {user_id} 已被授权。")

@bot.message_handler(commands=['list_users'])
def list_users(message):
    user_id = str(message.from_user.id)
    if user_id not in ADMIN_USERS:
        bot.send_message(message.chat.id, "您没有权限执行此操作。")
        return

    user_list = "\n".join(ALLOWED_USERS)
    bot.send_message(message.chat.id, f"当前授权用户列表:\n{user_list}")

@bot.message_handler(func=lambda message: message.text == "春洛批量三要素")
def batch_handler(message):
    user_id = str(message.from_user.id)
    if user_id not in ALLOWED_USERS:
        bot.send_message(message.chat.id, f"您无法使用该机器人,您的 UID 为: {user_id}")
        return

    bot.send_message(message.chat.id, "请输入 名字:")
    bot.register_next_step_handler(message, get_name)

def get_name(message):
    name = message.text.strip()
    if not name:
        bot.send_message(message.chat.id, "名字不能为空，请重新输入。")
        bot.register_next_step_handler(message, get_name)
        return
    bot.user_data = {'name': name}
    bot.send_message(message.chat.id, "请输入 手机号:")
    bot.register_next_step_handler(message, get_phone)

def get_phone(message):
    phone = message.text.strip()
    if not phone or not phone.isdigit():
        bot.send_message(message.chat.id, "手机号无效，请重新输入。")
        bot.register_next_step_handler(message, get_phone)
        return
    bot.user_data['phone'] = phone
    bot.send_message(message.chat.id, "请输入身份证,一行一个:")
    bot.register_next_step_handler(message, get_id_cards)

def get_id_cards(message):
    id_cards = message.text.strip().splitlines()
    if not id_cards:
        bot.send_message(message.chat.id, "身份证列表不能为空，请重新输入。")
        bot.register_next_step_handler(message, get_id_cards)
        return
    name = bot.user_data['name']
    phone = bot.user_data['phone']
    chat_id = message.chat.id
    process_batch(name, id_cards, phone, chat_id, bot)
def main():
    while True:
        try:
            bot.polling()
        except Exception as e:
            print(f"Bot 失去连接: {e}")
            time.sleep(5)

if __name__ == "__main__":
    main()
